package spotifymixerapi.api;

import spotifymixerapi.api.redis.Redis_Spotify_TrackObject;

import java.io.Serializable;

public class TrackDisplayInfoDto implements Serializable {

    String name;
    String image;
    String artistName;
    String duration;
    String id;

    public TrackDisplayInfoDto(Redis_Spotify_TrackObject trackObject, String artistName, String albumImage) {
        name=trackObject.getName();
        id=trackObject.getId();
        duration= millisToMinutesAndSeconds(trackObject.getDuration_ms());
        image=albumImage;
        this.artistName=artistName;
    }

    public String  millisToMinutesAndSeconds(int millis) {
        double minutes = Math.floor(millis / 60000);
        int seconds = ((millis % 60000) / 1000);
        return (int)minutes + ":" + (seconds < 10 ? "0" : "") + seconds;
    }

    public TrackDisplayInfoDto(String name, String image, String artistName, int duration) {
        this.name = name;
        this.image = image;
        this.artistName = artistName;
        this.duration = millisToMinutesAndSeconds(duration);
    }

    public TrackDisplayInfoDto() {
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getImage() {
        return image;
    }

    public void setImage(String image) {
        this.image = image;
    }

    public String getArtistName() {
        return artistName;
    }

    public void setArtistName(String artistName) {
        this.artistName = artistName;
    }

    public String getDuration() {
        return duration;
    }

    public void setDuration(String duration) {
        this.duration = duration;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Override
    public String toString() {
        return "TrackDisplayInfoDto{" +
                "name='" + name + '\'' +
                ", image='" + image + '\'' +
                ", artistName='" + artistName + '\'' +
                ", duration='" + duration + '\'' +
                ", id='" + id + '\'' +
                '}';
    }
}
