package spotifymixerapi.api.redis;

import spotifymixerapi.api.spotify.Spotify_AvailableDevicesResponse;
import spotifymixerapi.api.spotify.Spotify_DeviceObject;
import spotifymixerapi.api.spotify.Spotify_PlaybackState;

import java.io.Serializable;
import java.util.*;


public class Redis_SessionData implements Serializable {

    String sessionName;
    String owner;
    List<String> users = new ArrayList<>();
    LinkedHashMap<String,List<Spotify_DeviceObject>> devices = new LinkedHashMap<>();
    Spotify_DeviceObject selectedDevice;
    Map<String, String> currentlyPlayedTrack;
    LinkedHashMap<String,List<String>> sessionQueueMap = new LinkedHashMap<>();
    Spotify_PlaybackState playbackState;

    public Redis_SessionData() {
    }

    public Redis_SessionData(String sessionName, String owner, List<String> users,LinkedHashMap<String,List<Spotify_DeviceObject>> devices) {
        this.sessionName = sessionName;
        this.owner = owner;
        this.users = users;
        this.devices = devices;
    }

    public String getSessionName() {
        return sessionName;
    }

    public void setSessionName(String sessionName) {
        this.sessionName = sessionName;
    }

    public String getOwner() {
        return owner;
    }

    public void setOwner(String owner) {
        this.owner = owner;
    }

    public List<String> getUsers() {
        return users;
    }

    public void setUsers(List<String> users) {
        this.users = users;
    }

    public LinkedHashMap<String,List<Spotify_DeviceObject>> getDevices() {
        return devices;
    }

    public void setDevices(LinkedHashMap<String,List<Spotify_DeviceObject>> devices) {
        this.devices = devices;
    }

    public void addDevice(String userId, List<Spotify_DeviceObject> devices) {
        this.devices.put(userId,devices);
    }

    public Map<String, String> getCurrentlyPlayedTrack() {
        return currentlyPlayedTrack;
    }

    public void setCurrentlyPlayedTrack(String user, String track) {
        this.currentlyPlayedTrack = Collections.singletonMap(user,track);
    }

    public LinkedHashMap<String, List<String>> getSessionQueueMap() {
        return sessionQueueMap;
    }

    public void setSessionQueueMap(LinkedHashMap<String, List<String>> sessionQueueMap) {
        this.sessionQueueMap = sessionQueueMap;
    }

    public Spotify_DeviceObject getSelectedDevice() {
        return selectedDevice;
    }

    public void setSelectedDevice(Spotify_DeviceObject selectedDevice) {
        this.selectedDevice = selectedDevice;
    }

    public void setCurrentlyPlayedTrack(Map<String, String> currentlyPlayedTrack) {
        this.currentlyPlayedTrack = currentlyPlayedTrack;
    }

    public Spotify_PlaybackState getPlaybackState() {
        return playbackState;
    }

    public void setPlaybackState(Spotify_PlaybackState playbackState) {
        this.playbackState = playbackState;
    }

    @Override
    public String toString() {
        return "Redis_SessionData{" +
                "sessionName='" + sessionName + '\'' +
                ", owner='" + owner + '\'' +
                ", users=" + users +
                ", devices=" + devices +
                ", selectedDevice=" + selectedDevice +
                ", currentlyPlayedTrack=" + currentlyPlayedTrack +
                ", sessionQueueMap=" + sessionQueueMap +
                ", playbackState=" + playbackState +
                '}';
    }
}
