package spotifymixerapi.api.redis;

import spotifymixerapi.api.spotify.Spotify_Album;
import spotifymixerapi.api.spotify.Spotify_ExternalUrls;
import spotifymixerapi.api.spotify.Spotify_ImageObjectDto;
import spotifymixerapi.api.spotify.Spotify_SimplifiedArtistObject;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public class Redis_Spotify_Album  implements Serializable {
    Spotify_ExternalUrls external_urls;
    String href;
    String id;
    List<Spotify_ImageObjectDto> images;
    String name;
    String uri;
    List<String> artists = new ArrayList<>(); //Spotify_SimplifiedArtistObject

    public Redis_Spotify_Album(Spotify_ExternalUrls external_urls, String href, String id, List<Spotify_ImageObjectDto> images, String name, String uri, List<String> artists) {
        this.external_urls = external_urls;
        this.href = href;
        this.id = id;
        this.images = images;
        this.name = name;
        this.uri = uri;
        this.artists = artists;
    }

    public Redis_Spotify_Album() {
    }

    public Redis_Spotify_Album(Spotify_Album spotifyAlbum) {
        external_urls = spotifyAlbum.getExternal_urls();
        href = spotifyAlbum.getHref();
        id = spotifyAlbum.getId();
        images = spotifyAlbum.getImages();
        name = spotifyAlbum.getUri();
        uri = spotifyAlbum.getUri();
        spotifyAlbum.getArtists().stream().forEach(a -> this.artists.add(a.getId()));
    }

    public Spotify_ExternalUrls getExternal_urls() {
        return external_urls;
    }

    public void setExternal_urls(Spotify_ExternalUrls external_urls) {
        this.external_urls = external_urls;
    }

    public String getHref() {
        return href;
    }

    public void setHref(String href) {
        this.href = href;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public List<Spotify_ImageObjectDto> getImages() {
        return images;
    }

    public void setImages(List<Spotify_ImageObjectDto> images) {
        this.images = images;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getUri() {
        return uri;
    }

    public void setUri(String uri) {
        this.uri = uri;
    }

    public List<String> getArtists() {
        return artists;
    }

    public void setArtists(List<String> artists) {
        this.artists = artists;
    }

    @Override
    public String
    toString() {
        return "Redis_Spotify_Album{" +
                "external_urls=" + external_urls +
                ", href='" + href + '\'' +
                ", id='" + id + '\'' +
                ", images=" + images +
                ", name='" + name + '\'' +
                ", uri='" + uri + '\'' +
                ", artists=" + artists +
                '}';
    }
}
