package spotifymixerapi.api.redis;

import spotifymixerapi.api.spotify.Spotify_ExternalUrls;
import spotifymixerapi.api.spotify.Spotify_ImageObjectDto;
import spotifymixerapi.api.spotify.Spotify_Playlist;
import spotifymixerapi.api.spotify.Spotify_PlaylistTrack;

import java.io.Serializable;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

public class Redis_Spotify_Playlist implements Serializable {

    String description;
    Spotify_ExternalUrls external_urls;
    String href;
    String id;
    List<Spotify_ImageObjectDto> images;
    String name;
    Set<String> tracks = new HashSet<>();; //Redis_Spotify_TrackObject
    String uri;

    public Redis_Spotify_Playlist(String description, Spotify_ExternalUrls external_urls, String href, String id, List<Spotify_ImageObjectDto> images, String name, Set<String> tracks, String uri) {
        this.description = description;
        this.external_urls = external_urls;
        this.href = href;
        this.id = id;
        this.images = images;
        this.name = name;
        this.tracks = tracks;
        this.uri = uri;
    }

    public Redis_Spotify_Playlist() {
    }

    public Redis_Spotify_Playlist(Spotify_Playlist playlist) {
        description=playlist.getDescription();
        external_urls= playlist.getExternal_urls();
        href=playlist.getHref();
        id=playlist.getId();
        images=playlist.getImages();
        uri=playlist.getUri();
        name=playlist.getName();
        playlist.getTracks().getItems().stream().forEach(t -> this.tracks.add(t.getTrack().getId()));
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Spotify_ExternalUrls getExternal_urls() {
        return external_urls;
    }

    public void setExternal_urls(Spotify_ExternalUrls external_urls) {
        this.external_urls = external_urls;
    }

    public String getHref() {
        return href;
    }

    public void setHref(String href) {
        this.href = href;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public List<Spotify_ImageObjectDto> getImages() {
        return images;
    }

    public void setImages(List<Spotify_ImageObjectDto> images) {
        this.images = images;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Set<String> getTracks() {
        return tracks;
    }

    public void setTracks(Set<String> tracks) {
        this.tracks = tracks;
    }

    public String getUri() {
        return uri;
    }

    public void setUri(String uri) {
        this.uri = uri;
    }

    @Override
    public String toString() {
        return "Redis_Spotify_Playlist{" +
                "description='" + description + '\'' +
                ", external_urls=" + external_urls +
                ", href='" + href + '\'' +
                ", id='" + id + '\'' +
                ", images=" + images +
                ", name='" + name + '\'' +
                ", tracks=" + tracks +
                ", uri='" + uri + '\'' +
                '}';
    }
}
