package spotifymixerapi.api.redis;

import spotifymixerapi.api.spotify.Spotify_Album;
import spotifymixerapi.api.spotify.Spotify_ExternalUrls;
import spotifymixerapi.api.spotify.Spotify_SimplifiedArtistObject;
import spotifymixerapi.api.spotify.Spotify_TrackObject;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public class Redis_Spotify_TrackObject  implements Serializable {

    String album; //Spotify_Album Redis_Spotify_Album
    List<String> artists = new ArrayList<>(); //Spotify_SimplifiedArtistObject
    int duration_ms;
    Spotify_ExternalUrls external_urls;
    String href;
    String id;
    boolean is_playable;
    String name;
    String uri;

    public Redis_Spotify_TrackObject(String album, List<String> artists, int duration_ms, Spotify_ExternalUrls external_urls, String href, String id, boolean is_playable, String name, String uri) {
        this.album = album;
        this.artists = artists;
        this.duration_ms = duration_ms;
        this.external_urls = external_urls;
        this.href = href;
        this.id = id;
        this.is_playable = is_playable;
        this.name = name;
        this.uri = uri;
    }

    public Redis_Spotify_TrackObject() {
    }

    public Redis_Spotify_TrackObject(Spotify_TrackObject trackObject) {
        album = trackObject.getAlbum().getId();
        trackObject.getArtists().stream().forEach(a->this.artists.add(a.getId()));
        duration_ms = trackObject.getDuration_ms();
        external_urls = trackObject.getExternal_urls();
        href = trackObject.getHref();
        id = trackObject.getId();
        is_playable = trackObject.isIs_playable();
        name = trackObject.getName();
        uri = trackObject.getUri();
    }

    public String getAlbum() {
        return album;
    }

    public void setAlbum(String album) {
        this.album = album;
    }

    public List<String> getArtists() {
        return artists;
    }

    public void setArtists(List<String> artists) {
        this.artists = artists;
    }

    public int getDuration_ms() {
        return duration_ms;
    }

    public void setDuration_ms(int duration_ms) {
        this.duration_ms = duration_ms;
    }

    public Spotify_ExternalUrls getExternal_urls() {
        return external_urls;
    }

    public void setExternal_urls(Spotify_ExternalUrls external_urls) {
        this.external_urls = external_urls;
    }

    public String getHref() {
        return href;
    }

    public void setHref(String href) {
        this.href = href;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public boolean isIs_playable() {
        return is_playable;
    }

    public void setIs_playable(boolean is_playable) {
        this.is_playable = is_playable;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getUri() {
        return uri;
    }

    public void setUri(String uri) {
        this.uri = uri;
    }

    @Override
    public String toString() {
        return "Redis_Spotify_TrackObject{" +
                "album='" + album + '\'' +
                ", artists=" + artists +
                ", duration_ms=" + duration_ms +
                ", external_urls=" + external_urls +
                ", href='" + href + '\'' +
                ", id='" + id + '\'' +
                ", is_playable=" + is_playable +
                ", name='" + name + '\'' +
                ", uri='" + uri + '\'' +
                '}';
    }
}
