package spotifymixerapi.api.redis;

import spotifymixerapi.api.AccessTokenHolder;
import spotifymixerapi.api.spotify.Spotify_DeviceObject;
import spotifymixerapi.api.spotify.Spotify_Playlist;
import spotifymixerapi.api.spotify.Spotify_TrackObject;
import spotifymixerapi.api.spotify.Spotify_UserDtoResponse;

import java.io.Serializable;
import java.util.*;
import java.util.stream.Collectors;


public class Redis_UserData implements Serializable {

    Spotify_UserDtoResponse spotifyUserDtoResponse;
    List <String> likedTracks = new ArrayList<>();
    List <String> playlistList = new ArrayList<>();
    Boolean hasPremium = false;
    List <Spotify_DeviceObject> devices;
    List<String> queue = new ArrayList<>();
    String accessToken;


    public Redis_UserData() {
    }

    public Redis_UserData(Spotify_UserDtoResponse spotifyUserDtoResponse, List <String> likedTracks, List <String> playlistList, String accessToken) {
        this.spotifyUserDtoResponse = spotifyUserDtoResponse;
        this.likedTracks = likedTracks;
        this.playlistList = playlistList;
        this.accessToken = accessToken;
    }

    public Redis_UserData(List<Spotify_TrackObject> likedTracks, List<Spotify_Playlist> playlistLists,String accessToken){
        likedTracks.stream().forEach(l -> this.likedTracks.add(l.getId()));
        playlistLists.stream().forEach(l -> this.playlistList.add(l.getId()));
        this.accessToken = accessToken;
    }

    public Spotify_UserDtoResponse getSpotifyUserDtoResponse() {
        return spotifyUserDtoResponse;
    }

    public void setSpotifyUserDtoResponse(Spotify_UserDtoResponse spotifyUserDtoResponse) {
        this.spotifyUserDtoResponse = spotifyUserDtoResponse;
    }

    public List<String> getLikedTracks() {
        return likedTracks;
    }

    public void setLikedTracks(List<String> likedTracks) {
        this.likedTracks = likedTracks;
    }

    public List<String> getPlaylistList() {
        return playlistList;
    }

    public void setPlaylistList(List<String> playlistList) {
        this.playlistList = playlistList;
    }

    public Boolean getHasPremium() {
        return hasPremium;
    }

    public void setHasPremium(Boolean hasPremium) {
        this.hasPremium = hasPremium;
    }

    public List<Spotify_DeviceObject> getDevices() {
        return devices;
    }

    public void setDevices(List<Spotify_DeviceObject> devices) {
        this.devices = devices;
    }

    public List<String> getQueue() {
        return queue;
    }

    public void setQueue(List<String> queue) {
        this.queue = queue;
    }

    public String getAccessToken() {
        return accessToken;
    }

    @Override
    public String toString() {
        return "Redis_UserData{" +
                "spotifyUserDtoResponse=" + spotifyUserDtoResponse +
                ", likedTracks=" + likedTracks +
                ", playlistList=" + playlistList +
                ", hasPremium=" + hasPremium +
                ", devices=" + devices +
                ", queue=" + queue +
                '}';
    }
}
